

#include "C_MetalSlug.h"


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//															function implementation: MetalSlug class
// : player tank
MetalSlug::MetalSlug()
{
	fv_Color_base[0] = 0.3294;
	fv_Color_base[1] = 0.4313;
	fv_Color_base[2] = 0.5058;
	fv_Color_silver[0] = 0.7;
	fv_Color_silver[1] = 0.7;
	fv_Color_silver[2] = 0.7;

	pos.x = 400; pos.y = 0; pos.z = 400;
	facing.hor_angle = 180; facing.ver_angle = 0; rolling = 0;

	gun_facing_abs.hor_angle = 180; gun_facing_abs.ver_angle = 0;
	gun_facing_rel = abs2rel(0,0,0,gun_facing_abs);

	turning = 0; moving = 0;trackINDEX = 0;

	speed = METALSLUG_SPEED/FPS_CAP;
	radius = 2;
	health = 2000;

	turning = 0; 
	moving = STAY;

	b_detail = true;

	n_Hit = 0;

	// Load the model
	Const_LoadMod();


	//// GUN FIRE 
	n_GUNSPEED = 12;
	
	n_LgunPan = 0;
	n_LgunPitch = 0;
	n_LgunSpin = 0;
	n_LgunSpinSPEED = n_GUNSPEED;

	n_RgunPan = 0;
	n_RgunPitch = 0;
	n_RgunSpin = 0;
	n_RgunSpinSPEED = n_GUNSPEED;
	
	LGUNSPIN_counter = 0;
	LGUNROTATE_counter = 0;
	LGUNSPDS_counter = 0;
	
	RGUNSPIN_counter = 0;
	RGUNROTATE_counter = 0;
	RGUNSPDS_counter = 0;
	//// GUN FIRE END

	n_LeftGunSTATE = 0;
	n_RightGunSTATE = 0;

	f_IDLEshake = 0;
	f_IDLEshake1 = 0;
}

void MetalSlug::drawTank(bool DETAIL)
{

		float white[4] = {0.0013, 0.0013, 0.0013, 1.0};
	glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT0, GL_SPECULAR, white);

	float pitch;
	terrain->VehicleCollision(pos.x, pos.z-.5, pos.x, pos.z+.5, pos.x-.5, pos.z, pos.x+.5, pos.z, pitch, rolling);

	rolling *= R2D;
	facing.ver_angle = pitch*R2D;

	glPushMatrix();

	glTranslated(pos.x, pos.y+1, pos.z);
	
	glRotatef(facing.ver_angle, 1,0,0);
	glRotatef(rolling, 0,0,1);
	glRotated(facing.hor_angle, 0,1,0);

	glPushMatrix();
	glScalef(0.001,0.001,0.001);
	
	glPushMatrix();
	glTranslatef(-360, 260, -20);
	glRotatef(gun_facing_rel.hor_angle, 0,1,0);
	glRotatef(gun_facing_rel.ver_angle, 1,0,0);
		glTranslatef(-360, 0, 20);
		glCallList(Dlid_D_GunBarrel);
		glCallList(Dlid_D_GunBase);	
	glPopMatrix();

	glTranslatef(360, 260, -20);
	glRotatef(gun_facing_rel.hor_angle, 0,1,0);
	glRotatef(gun_facing_rel.ver_angle, 1,0,0);
		glTranslatef(-360, 0, 20);
		glCallList(Dlid_D_GunBarrel);
		glCallList(Dlid_D_GunBase);	
	glPopMatrix();

	//glRotatef(180,0,1,0);
	//glScalef(0.01,0.01,0.01);
	MS_Display(DETAIL);

	//glutSolidCube(1);

	//glColor3f(1,1,1);
	//glPushMatrix();
	//glRotatef(player->gun_facing_rel.hor_angle, 0,1,0);
	//glRotatef(player->gun_facing_rel.ver_angle, 1,0,0);
	//	glScalef(1,1,10);
	//	glutSolidCube(1);
	//glPopMatrix();

	//glutSolidCube(2);
	//glTranslated(0,0,-1);
	//glColor3f(1,0,0);
	//glutSolidCube(2);
	//glColor3f(1,1,1);
	glPopMatrix();


	if(moving == 1)
	{if(trackINDEX < 4) trackINDEX++;
	else trackINDEX = 0;
	}
	if(moving == 2)
	{if(trackINDEX > 0) trackINDEX--;
	else trackINDEX = 4;
	}
	white[0] = 1.0;
	white[1] = 1.0;
	white[2] = 1.0;
	white[3] = 1.0;
	glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT0, GL_SPECULAR, white);
}

void MetalSlug::processAction()
// run in idle, process user input to player tank, also sets the camera position .. not facing 
// facing is on mouse control
{
	// ::................................................... [ handles player movement command ]
	facing.hor_angle += turning/FPS_CAP*btfactor/100.0;
	if (facing.hor_angle >= 360) facing.hor_angle -= 360; // make sure it's with 0-360 range
	if (facing.hor_angle < 0) facing.hor_angle += 360;

	gun_facing_rel = abs2rel(-rolling,-player->facing.ver_angle,-player->facing.hor_angle, player->gun_facing_abs); 

	// processing displacement
	if (moving !=0)
	{
		float	x_displacement = sin( (facing.hor_angle)*PI/180 ) * speed * btfactor/100.0,
			z_displacement = cos( (facing.hor_angle)*PI/180 ) * speed * btfactor/100.0;

		if (moving == 2) { 
			facing.hor_angle -= 2*turning/FPS_CAP*btfactor/100.0;
			x_displacement *= -1;
			z_displacement *= -1;
		}
		pos.z = pos.z + z_displacement; pos.x = pos.x + x_displacement;
		// check game object collision
 
		if (isCollide(pos, radius, _PLAYER, -1)) {
			// check for sliding // auto avoid collision
			pos.x -= x_displacement;
			if (isCollide(pos, radius, _PLAYER, -1)) {
				pos.z -= z_displacement; pos.x += x_displacement;
				if (isCollide(pos, radius, _PLAYER, -1)) 
					pos.x -= x_displacement;
			}
		}
		pos.y = terrain->CollisionPoint(pos.x, pos.z);
	}
}


void MetalSlug::fireBullet()
{
	for (int i = BULLET_BASE; i <= BULLET_CAP; i++) {
		if (particles[i] == NULL) {
			WORLD_COOR w = player->pos; w.y++;
			particles[i] = new Particle(player->gun_facing_abs, w, _BULLET, 5);
			n_BF++;
			break;
		}
	}
}

void MetalSlug::fireMissile()
{
	for (int i = SB_BASE; i<=SB_CAP; i++) {
		if (particles[i] == NULL) {
			FACING f = player->facing;  f.ver_angle = 320;
			WORLD_COOR w = player->pos; w.y = 2;
			particles[i] = new Particle(f, player->pos, _SMART_BOMB, 600);
			break;
		}
	}
}

bool MetalSlug::Const_LoadMod()
{
	// low detail
	obj_CannonIn.loadObj("obj/SV/CannonIn.obj");
	obj_CannonOut.loadObj("obj/SV/CannonOut.obj");
	obj_GunBarrel.loadObj("obj/SV/GunBarrel.obj");
	obj_GunBase.loadObj("obj/SV/GunBase.obj");
	obj_Main.loadObj("obj/SV/Main.obj");
	obj_Top_Blue.loadObj("obj/SV/tb11.obj");
	obj_Top_Silver.loadObj("obj/SV/Top_Silver.obj");
	obj_Track.loadObj("obj/SV/Track.obj");
	obj_Track1.loadObj("obj/SV/Track1.obj");
	obj_Track2.loadObj("obj/SV/Track2.obj");
	obj_Track3.loadObj("obj/SV/Track3.obj");
	obj_Track4.loadObj("obj/SV/Track4.obj");
	OBJ_CanIn.loadObj("obj/SV/DETAIL/CanIn.obj");
	OBJ_CanOut.loadObj("obj/SV/DETAIL/CanOut.obj");

	// OBJ_Exhaust.loadObj("obj/SV/DETAIL/Exhaust.obj");

	 OBJ_GunBarrel.loadObj("obj/SV/DETAIL/GunBarrel.obj");
	 OBJ_GunBaseB.loadObj("obj/SV/DETAIL/GunBase_b.obj");
	 OBJ_GunBaseS.loadObj("obj/SV/DETAIL/GunBase_s.obj");
	 OBJ_Main.loadObj("obj/SV/DETAIL/Main.obj");
	 OBJ_TB.loadObj("obj/SV/DETAIL/TopBlue.obj");
	 OBJ_TS.loadObj("obj/SV/DETAIL/TopSilver.obj");
	 OBJ_Track0.loadObj("obj/SV/DETAIL/track0.obj");
	 OBJ_Track1.loadObj("obj/SV/DETAIL/track1.obj");
	 OBJ_Track2.loadObj("obj/SV/DETAIL/track2.obj");
	 OBJ_Track3.loadObj("obj/SV/DETAIL/track3.obj");
	 OBJ_Track4.loadObj("obj/SV/DETAIL/track4.obj");

	Dlid_Cannon = glGenLists(20);
	Dlid_GunBase= glGenLists(20);
	Dlid_GunBarrel= glGenLists(20);
	Dlid_Main = glGenLists(20);
	Dlid_Top = glGenLists(20);
	Dlid_Track = glGenLists(20);
	Dlid_Track1 = glGenLists(20);
	Dlid_Track2 = glGenLists(20);
	Dlid_Track3 = glGenLists(20);
	Dlid_Track4 = glGenLists(20);

	Dlid_D_Cannon = glGenLists(20);
	Dlid_D_GunBase = glGenLists(20);
	Dlid_D_GunBarrel = glGenLists(20);
	Dlid_D_Main = glGenLists(20);
	Dlid_D_Top = glGenLists(20);
	Dlid_D_Track = glGenLists(20);
	Dlid_D_Track1 = glGenLists(20);
	Dlid_D_Track2 = glGenLists(20);
	Dlid_D_Track3 = glGenLists(20);
	Dlid_D_Track4 = glGenLists(20);

	CDL_crappy();
	CDL_good();
	return true;
}


void MetalSlug::CDL_crappy()
{
	// Cannon
	glNewList(Dlid_Cannon, GL_COMPILE);

	glColor3fv(fv_Color_silver);

	obj_CannonIn.displayObj();

	glColor3fv(fv_Color_base);

	obj_CannonOut.displayObj();

	glEndList();
	
	// GunBase
	 glNewList(Dlid_GunBase, GL_COMPILE);
	 glColor3fv(fv_Color_base);
	 obj_GunBase.displayObj();
	 glEndList();
	 

	 // GunBarrel
	 glNewList(Dlid_GunBarrel, GL_COMPILE);
	 glColor3fv(fv_Color_silver);
	 obj_GunBarrel.displayObj();
	 glEndList();
	 
	 // Main
	 glNewList(Dlid_Main, GL_COMPILE);
	 glColor3fv(fv_Color_base);
	 obj_Main.displayObj();
	 glEndList();
	 
	 // Top
	 glNewList(Dlid_Top, GL_COMPILE);
	 glColor3fv(fv_Color_base);
	 obj_Top_Blue.displayObj();
	 glColor3fv(fv_Color_silver);
	 obj_Top_Silver.displayObj();
	 glEndList();
	 
	 // Track0
	 glNewList(Dlid_Track, GL_COMPILE);
	 glColor3fv(fv_Color_silver);
	 obj_Track.displayObj();
	 glEndList();
}


void MetalSlug::CDL_good()
{
		// Cannon
	glNewList(Dlid_D_Cannon, GL_COMPILE);

	glColor3fv(fv_Color_silver);
	glPushMatrix();
	glRotatef(90,1,0,0);
	OBJ_CanIn.displayObj();
	//OBJ_CanIn2.displayObj();
	//OBJ_CanIn3.displayObj();

	glColor3fv(fv_Color_base);

	OBJ_CanOut.displayObj();
	//OBJ_CanOut2.displayObj();
	//OBJ_CanOut3.displayObj();
	glPopMatrix();
	glEndList();
	
	// GunBase
	 glNewList(Dlid_D_GunBase, GL_COMPILE);
	 	glPushMatrix();
	glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_base);
	 OBJ_GunBaseB.displayObj();
	 glColor3fv(fv_Color_silver);
	 OBJ_GunBaseS.displayObj();
	 glPopMatrix();
	 glEndList();
	 

	 // GunBarrel
	 glNewList(Dlid_D_GunBarrel, GL_COMPILE);
	 	glPushMatrix();
	glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_silver);
	 OBJ_GunBarrel.displayObj();
	 glPopMatrix();
	 glEndList();
	 
	 // Main
	 glNewList(Dlid_D_Main, GL_COMPILE);
	 	glPushMatrix();
	glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_base);
	 OBJ_Main.displayObj();
	 //OBJ_Main2.displayObj();
	 //OBJ_Main3.displayObj();
	 //OBJ_Main4.displayObj();
	 glPopMatrix();
	 glEndList();
	 
	 // Top
	 glNewList(Dlid_D_Top, GL_COMPILE);
	 	glPushMatrix();
	glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_base);
	 OBJ_TB.displayObj();
	 //OBJ_TB2.displayObj();
	 //OBJ_TB3.displayObj();
	 //OBJ_TB4.displayObj();
	 //OBJ_TB5.displayObj();


	glColor3fv(fv_Color_silver);
	OBJ_TS.displayObj();
	glPopMatrix();
	 /////
	 glEndList();
	 
	 // Track0
	 glNewList(Dlid_D_Track, GL_COMPILE);
	 	glPushMatrix();
	 glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_silver);
	 OBJ_Track0.displayObj();
	 glPopMatrix();
	 glEndList();

	 	 glNewList(Dlid_D_Track1, GL_COMPILE);
	 	glPushMatrix();
	 glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_silver);
	 OBJ_Track1.displayObj();
	 glPopMatrix();
	 glEndList();
	 	 glNewList(Dlid_D_Track2, GL_COMPILE);
	 	glPushMatrix();
	 glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_silver);
	 OBJ_Track2.displayObj();
	 glPopMatrix();
	 glEndList();
	 	 glNewList(Dlid_D_Track3, GL_COMPILE);
	 	glPushMatrix();
	 glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_silver);
	 OBJ_Track3.displayObj();
	 glPopMatrix();
	 glEndList();

	 	 glNewList(Dlid_D_Track4, GL_COMPILE);
	 	glPushMatrix();
	 glRotatef(90,1,0,0);
	 glColor3fv(fv_Color_silver);
	 OBJ_Track4.displayObj();
	 glPopMatrix();
	 glEndList();

}



void MetalSlug::MS_Display(bool d)
{
	// Lighting Hack

		glPushMatrix();
		glRotatef(180, 0, 1, 0);
		glScalef(0.001,0.001,0.001);

		glRotatef(-90,1,0,0);  ////////////////////////////////////<<<<<<<<<<<<<<<<< ROTATE >>>>>>>>>>
			glPushMatrix();
				glTranslatef(0,0,f_IDLEshake);
			if(d)glCallList(Dlid_D_Main);
			else glCallList(Dlid_Main);

			glPopMatrix();


			
			//// GUN RIGHT END
	
			
	
			//// GUN LEFT END
	            glPushMatrix();
				glTranslatef(0,0,-f_IDLEshake);

						if(d){ glCallList(Dlid_D_Top);}
						else glCallList(Dlid_Top);

                        glPushMatrix();
								
                                glTranslatef(0,0,0);
                               
                               if(d) glCallList(Dlid_D_Cannon);
							   else glCallList(Dlid_Cannon);
                                
                        glPopMatrix();
                        
                glPopMatrix();  
                glPushMatrix();
                        //Right Track
                        glTranslatef(0,0,0); 

						//if(moving != 0
					if(trackINDEX == 0)glCallList(Dlid_D_Track);
					if(trackINDEX == 1)glCallList(Dlid_D_Track1);
					if(trackINDEX == 2)glCallList(Dlid_D_Track2);
					if(trackINDEX == 3)glCallList(Dlid_D_Track3);
					if(trackINDEX == 4)glCallList(Dlid_D_Track4);


			//Left Track
			glPushMatrix();
		//	
			glTranslatef(-490,0,0);
			//glScalef(-1,0,0);
					if(trackINDEX == 0)glCallList(Dlid_D_Track);
					if(trackINDEX == 1)glCallList(Dlid_D_Track1);
					if(trackINDEX == 2)glCallList(Dlid_D_Track2);
					if(trackINDEX == 3)glCallList(Dlid_D_Track3);
					if(trackINDEX == 4)glCallList(Dlid_D_Track4);


			glPopMatrix();
            glPopMatrix();

        glPopMatrix();

	// Return lighting back from hack

}
