// [ player.h :::::::::::::::::::::::: ] //

/* memo	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	player tank
	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/

#ifndef _METALSLUG_H
#define _METALSLUG_H

// ------------------------------------------------------------------------------------------------
#include "HT_Global.h"
#include "objreader.h"

#define STAY 0
#define FORWARD 1
#define BACKWARmD 2


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																		class def: MetalSlug class
// : player tank
class MetalSlug
{
public:
	
		// Gun Angle

	int n_GUNSPEED;
	int n_LgunPan;
	int n_LgunPitch;
	int n_LgunSpin;
	int n_LgunSpinSPEED;
	
	int n_RgunPan;
	int n_RgunPitch;
	int n_RgunSpin;
	int n_RgunSpinSPEED;
	
	//// Position
	//float db_PosX, db_PosZ;
	
	//// Health
	int n_Hit;
	//// Misc
	bool b_HeadLamp;
	float f_IDLEshake;
	float f_IDLEshake1;
	float IDLE_counter;
	float RESPOND_counter;
	
	// frame things
	float LGUNSPIN_counter;
	float LGUNROTATE_counter;
	float LGUNSPDS_counter;
	
	float RGUNSPIN_counter;
	float RGUNROTATE_counter;
	float RGUNSPDS_counter;
	

	int n_LeftGunSTATE;  // 0 rest 1 fire 2 recover
	int n_RightGunSTATE;


	// Tracks Speed counter
	float TrackSpeed_counter;
	float De_counter;
	float Friction;
	float Speed;
	float Track_speed;
	bool b_SlowDown;
	int n_LeftTrackINDEX;
	int n_RightTrackINDEX;

	// :: settings ::
	float speed;

	bool b_detail;
	
	GLint Dlid_Cannon,
	Dlid_GunBase,
	Dlid_GunBarrel,
	Dlid_Main,
	Dlid_Top,
	Dlid_Track,
	Dlid_Track1,
	Dlid_Track2,
	Dlid_Track3,
	Dlid_Track4;

	GLint Dlid_D_Cannon,
	Dlid_D_GunBase,
	Dlid_D_GunBarrel,
	Dlid_D_Main,
	Dlid_D_Top,
	Dlid_D_Track,
	Dlid_D_Track1,
	Dlid_D_Track2,
	Dlid_D_Track3,
	Dlid_D_Track4;

	objReader obj_CannonIn;
	objReader obj_CannonOut;
	objReader obj_GunBarrel;
	objReader obj_GunBase;
	objReader obj_Main;
	objReader obj_Top_Blue;
	objReader obj_Top_Silver;
	objReader obj_Track;
	objReader obj_Track1;
	objReader obj_Track2;
	objReader obj_Track3;
	objReader obj_Track4;

	// Detail
	objReader OBJ_CanIn;

	objReader OBJ_CanOut;

	objReader OBJ_Exhaust;

	objReader OBJ_GunBarrel;

	objReader OBJ_GunBaseB;

	objReader OBJ_GunBaseS;

	objReader OBJ_Main;

	objReader OBJ_TB;
	objReader OBJ_TS;
	objReader OBJ_Track0;
	objReader OBJ_Track1;
	objReader OBJ_Track2;
	objReader OBJ_Track3;
	objReader OBJ_Track4;

	// :::::::::::::::::::::::::::::::::::::::::: [ variables ]
	// :: curr state :: these should only be changed by processAction()
	WORLD_COOR pos;
	FACING facing; float rolling;
	FACING gun_facing_abs, gun_facing_rel;	// gun facing is not frame based, only exception
	int health;

	// :: constant throughout game
	int radius;

	// :: to desired next state :: indicators, changed by use input
	int turning, moving, trackINDEX;
	
	// rolling is updated whenever move is successful

    // :::::::::::::::::::::::::::::::::::::::::: [ functions ]
	MetalSlug();
	bool Const_LoadMod();
	void CDL_good();
	void CDL_crappy();
	void MS_Display(bool d);
    void move(WORLD_COOR coor);
	void processAction();

	void fireBullet();
	void fireMissile();
	void fireWalkingBomb();

	void drawTank(bool DETAIL);

	float fv_Color_base[3];
	float fv_Color_silver[3];
};
// ------------------------------------------------------------------------------------------------
#endif /* player.h */