
#include "C_Particle1.h"




Particle::Particle(FACING facing, WORLD_COOR pos, int type, int health)
{
	this->pos = pos;
	this->type = type;

	this->facing = facing;

	tar_locked = false;
	n_rotate = rand()%10;

	//// set facing
	//else {
	//	WORLD_COOR vec = world_coor_add(target.x, target.y, target.z, -pos.x, -pos.y, -pos.z);
	//	facing = Vec2Angle(vec.x, vec.y, vec.z);
	//}
	this->health = health;
}


void Particle::processAction()
{
	// .1 ask brain for newpos
	newpos = particle_wherenext(this);
	move();
	//cout << newpos.x << " " << newpos.y << " " << newpos.z << endl;
}

void Particle::move()
{
	if (tryMove()) {
		pos = newpos;
	}
	else if (health > 2) {
		health = -10000;
	}
	else health = -1;
}

bool Particle::tryMove()
{
	return !isOutofview() &&  !isBelowfloor() && true;
}

void Particle::drawParticle()
{
	WORLD_COOR w;
	FACING f;
	switch(type) {
		case _BULLET: // bullet
			w= world_coor_add(camera.pos.x,camera.pos.y,camera.pos.z, -pos.x,-pos.y,-pos.z);
			f = Vec2Angle(w.x, w.y, w.z);

			glPushMatrix();
			glDisable(GL_LIGHTING);
			glColor4f(1,1,1,1);
			glTranslatef(pos.x, pos.y, pos.z);
			glRotatef(f.hor_angle,0,1,0);
			glRotatef(f.ver_angle,1,0,0);

			// if want to spin, ctrl+u me
//glTranslatef(1,0,0);
glRotatef(currTime/n_rotate,0,0,1);
//glTranslatef(-1,0,0);
			
			glBlendFunc(GL_DST_COLOR,GL_ZERO);
			glEnable(GL_BLEND);									

			T_pMASK.SetActive();
			drawTexturedQuad(-1.2,-1.2,1.2,1.2);
			glBlendFunc(GL_ONE,GL_ONE);

			T_p.SetActive();

			drawTexturedQuad_f(-1.2,-1.2,1.2,1.2);
			glDisable(GL_BLEND);
			glEnable(GL_LIGHTING);


			glPopMatrix();
			break;
		case 2: // smart_bomb
			glPushMatrix();
			glColor3f(0.1,1,0);
			glTranslatef(pos.x, pos.y, pos.z);
			glRotatef(facing.hor_angle,0,1,0);
			glRotatef(facing.ver_angle,1,0,0);
			glRotatef(currTime/2,0,0,1);
			glScalef(1.5,1.5,1.5);
			MD_MISS();
			glColor3f(1,1,1);
			glPopMatrix();
			break;
		case 3: // walking bomb
			glPushMatrix();
			glColor3f(0.1,1,0);
			glTranslatef(pos.x, pos.y, pos.z);
			glutSolidCube(3);
			glColor3f(1,1,1);
			glPopMatrix();
			break;

		case _BOMB: // bomb
			glPushMatrix();
			glColor3f(1,1,0);
			glTranslatef(pos.x, pos.y, pos.z);
			glRotatef(facing.hor_angle,0,1,0);
			glRotatef(facing.ver_angle,1,0,0);
			glRotatef(currTime,0,0,1);
			MD_SH();
			glColor3f(1,1,1);
			glPopMatrix();
			break;
	}
}

bool Particle::isOutofview()
{
	return ( veclength(world_coor_add(-pos.x, -pos.y, -pos.z, player->pos.x, player->pos.y, player->pos.z)) > 200 );
}
bool Particle::isBelowfloor()
{
	return (pos.y < terrain->CollisionPoint(pos.x, pos.z)); // here we need get height from terrain
}