// [ particle.h :::::::::::::::::::::::: ] //

/* memo	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	game object will ask this brain for their next move
	player tank will ask user what to do

	IMPORTANT::
	I hav all 4 types of particles sharing the same class, rather then inhereting,,
	since :: no much difference, so confusion is tolerable
	BUT, REMEMBER THAT:
	when initial -->	1. set type
						2. set all common variables and its special variables

	please initial all particle with health > 3, so it can fly out of gun,, then hit detect
	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/

#ifndef _PARTICLE1_H
#define _PARTICLE1_H

// ------------------------------------------------------------------------------------------------
#include "HT_Global.h"
#include "C_Brain.h"
#include "3DS_ObjectLoader.h"
#include "drawingFuncDump.h"



class Particle
{
	// particle is moving since born,,
public:
	// :: variable ::
	WORLD_COOR pos;
	WORLD_COOR target;
	FACING facing;
	// may be : the angle to camera... for billboard
	int type; bool tar_locked;

	// :: different things for different type
	// : bullet - nothing
	// : smart_bomb // facing????
	// : walking_bomb - nothing
	// : shell
	WORLD_COOR center;

	WORLD_COOR newpos;

	int health;
	int n_rotate;

	// here's how it works.. at every frame,, it asks brain for it's newpos.
	// then it trymoves to the newpos --- well,, if not,, maybe turn a bit..

	Particle(FACING facing, WORLD_COOR pos, int type, int health);
	// :: function ::
	void processAction();
	void move();
	bool tryMove();

	bool isOutofview();
	bool isBelowfloor();


	void drawParticle();
};

// ------------------------------------------------------------------------------------------------
#endif /* particle.h */
