// ------------------------------------------------------------------------------------------------
#include "HT_Control.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																					control functions in game

//																					1> passive mouse function
// controls camera look at
// . actually this sets gun's pointing, then camera is updated accordingly
double pastMouseX = RES_X/2, pastMouseY = RES_Y/2;
double deltax, deltay; double temp;


void MousePassiveFunc(int x, int y)
{
	deltax = x - pastMouseX; deltay = y - pastMouseY;

	// up/down
	temp = player->gun_facing_abs.ver_angle + deltay/8;

	if (temp > 360) temp -= 360;
	if (temp < 0) temp += 360;

	if (temp > 6 && temp < 180) temp = 6;		// cap gun angle
	if (temp >= 180 && temp < 300) temp = 300;

	player->gun_facing_abs.ver_angle = temp;

	// now left/rite
	temp = player->gun_facing_abs.hor_angle - deltax/8;

	if (temp > 360) temp -= 360;
	if (temp < 0) temp += 360;

	player->gun_facing_abs.hor_angle = temp;

	uniformFacing(&player->gun_facing_abs);

	if ( x > RES_X-50 || y > RES_Y-50 || x < 50 || y < 50) {	// need to set mouse to center
		glutWarpPointer(RES_X/2, RES_Y/2);
		x = pastMouseX = RES_X/2; y = pastMouseY = RES_Y/2;
	}
	pastMouseX = x; pastMouseY = y;
}

//																					1.1> mouse control
// . open fire / right click to jump
void MouseFunc(int button, int state, int x, int y)
{
	if (state == GLUT_DOWN) {
		if (button == GLUT_LEFT_BUTTON) {
			player->fireBullet();
		}
		else if (button == GLUT_RIGHT_BUTTON) {
			
			// jump
			/// giz,, this is time based,, so set a jump in player,, then player should jump a bit in each frame
		}
	}
	else if (state == GLUT_UP) {
		// here's david's gun slow down motion..
		b_LeftDown = false;
		n_FIRE = 0;
	}
}

//																					2> keyboard
// move / turn player tank
void keyboard_control(unsigned char c, int x, int y) 
{
	switch (c) {
	case 27:
		exit (0);
		break;

	// :::::::::::::::::::::::::::::::::::::::::: [ direction control ]
		// all time based movement,, so ask player to do it in the next frame by setting a argument in player->
	case 'a':
		player->turning = METALSLUG_TURNING_SPEED;
		break;
	case 'd':
		player->turning = -METALSLUG_TURNING_SPEED;
		break;
	case 'w':
		player->moving = 1;
		break;
	case 's':
		player->moving = 2;
		break;
	case 'p':
		writeMsg = !writeMsg;
		break;

		// :: firing ::
	case 'r':
		player->fireMissile();
		break;
	case ' ':
		if (btfactor > 50) btfactor = 30;
		else btfactor = 100;
		break;

	case 'g':
		WORLD_COOR w = player->pos; w.y = 12;
		emitParticle(w, _DUST_M, 10);
		break;


	//case 'n':
	//	if ( (player->gun_facing.ver_angle >=0 && player->gun_facing.ver_angle < 3) ||
	//		(player->gun_facing.ver_angle >= 300 && player->gun_facing.ver_angle <= 360))	player->gun_facing.ver_angle += 3;
	//	if (player->gun_facing.ver_angle > 360) player->gun_facing.ver_angle -=360;
	//	break;
	//case 'h':
	//	if ( (player->gun_facing.ver_angle >=0 && player->gun_facing.ver_angle <= 3) ||
	//		(player->gun_facing.ver_angle > 300 && player->gun_facing.ver_angle <= 360))	player->gun_facing.ver_angle -= 3;
	//	if (player->gun_facing.ver_angle < 0) player->gun_facing.ver_angle +=360;
	//	break;
	//case 'b':
	//	player->gun_facing.hor_angle += 10;
	//	if (player->gun_facing.hor_angle >= 360) player->gun_facing.hor_angle -= 360;
	//	break;
	//case 'm':
	//	player->gun_facing.hor_angle -= 10;
	//	if (player->gun_facing.hor_angle < 0) player->gun_facing.hor_angle += 360;
	//	break;
	}
}


//																					2.1> keyboard up
void keyboard_up(unsigned char c, int x, int y)
{
	switch (c) {
	// :::::::::::::::::::::::::::::::::::::::::: [ direction control ]
	case 'a':
	case 'd':
		player->turning = 0;
		break;
	case 'w':
	case 's':
		player->moving = 0;
		break;
	case 'l':
		//player->b_detail =! player->b_detail;
		break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																					control functions in menu
void menuMousePassiveFunc(int x, int y)
{
	if ( n_ScreenX/10 < x && x < n_ScreenX*.6 && .7*n_ScreenY < y && y < .8*n_ScreenY)
	{
		n_TimeMode = 1;
	}
	else if(n_TimeMode == 1)
	{
		n_TimeMode = 0;
	}
}
void menuMouseFunc(int button, int state, int x, int y)
{
	if (state == GLUT_DOWN && button == GLUT_LEFT_BUTTON && n_ScreenX/10 < x && x < n_ScreenX*.6 && .7*n_ScreenY < y && y < .8*n_ScreenY)
	{
		// here we start loading the game
		n_GameMode = 2;
	}
}
		
		
// ------------------------------------------------------------------------------------------------
// end of file "control.cpp"