// [ driver.cpp :::::::::::::::::::::: ] //

/* memo :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	here is where everything starts
	this file is intended to be clean and clear
	user interaction functions are put into control.cpp // as global functions
	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/

// ------------------------------------------------------------------------------------------------
#include "HT_Global.h"
#include "HT_Control.h"
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																				picking help functions
#define BUFSIZE 1024
GLuint selectBuf[BUFSIZE];
GLint hits;

float f_BulletTime = 1.0;
float f_BulletTimeTrance = 15.0;

double BT_counter = 0;
bool b_Pause = false;
MenuBack*  MB_array[80];

void startPicking()
{
	GLint viewport[4];
	float ratio;

	glSelectBuffer(BUFSIZE,selectBuf);

	glGetIntegerv(GL_VIEWPORT,viewport);

	glRenderMode(GL_SELECT);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	gluPickMatrix(n_ScreenX/2,n_ScreenY/2,2,2,viewport);

	ratio = (viewport[2]+0.0) / viewport[3];
	gluPerspective(90, ratio,0.1,12000);

	glMatrixMode(GL_MODELVIEW);
	glInitNames();
}

void processHits2 (GLint hits, GLuint buffer[], int sw)
{
	GLint i, numberOfNames;
   GLuint names, *ptr, minZ,*ptrNames;

   ptr = (GLuint *) buffer;
   minZ = 0xffffffff;
   for (i = 0; i < hits; i++) {	
      names = *ptr;
	  ptr++;
	  if (*ptr < minZ) {
		  numberOfNames = names;
		  minZ = *ptr;
		  ptrNames = ptr+2;
	  }
	  
	  ptr += names+2;
	}
   if (numberOfNames ==1) {
	 int a = *ptrNames;
	 if (a < BLOCK_NUM) missile_target = blocks[a]->pos;
	 else missile_target = tanks[a - BLOCK_NUM]->pos;
	}
}
void stopPicking() {

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();
	hits = glRenderMode(GL_RENDER);
	if (hits != 0){
		processHits2(hits,selectBuf,0);
	}
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																				render functions
// renderScene, main render fucntion in game
int firsttime = 2;
void renderScene() 
{
	//glutSetWindow(mainWindow);  
	//printFPS();


	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glClearColor(1.0, 1.0, 1.0, 1.0);

	gluLookAt(camera.pos.x, camera.pos.y, camera.pos.z, camera.lookAt.x, camera.lookAt.y, camera.lookAt.z, 0,1,0);
	//gluLookAt(25,50,0, 25,0,-25,0,1,0);

	terrain->draw(camera.pos.x, camera.pos.z);

	if (firsttime > 0) firsttime--;
	else if (firsttime ==0) {
	for (int i=0; i<50; i++) {
		float y = terrain->CollisionPoint(deco[i]->pos.x, deco[i]->pos.z);
		deco[i]->pos.y = y;
		cout << y << endl;
		firsttime--;
	}
	cout << " here" << endl;
	}

	// :: draw current scene ::
	// :: - draw player
	player->drawTank(true);

	// :: - draw blocks
	for (int i=0; i<BLOCK_NUM; i++) {
		blocks[i]->drawBlock();
	}
	for (int i=0; i<50; i++) {
		deco[i]->drawBlock();
	}
	for (int i=0; i<ENEMY_NUM; i++) {
		if (tanks[i] != NULL)
		tanks[i]->drawTank();
	}

	for (int i=0; i<BULLET_NUM+SMART_BOMB_NUM+WALKING_BOMB_NUM+BOMB; i++) {
		if (particles[i] != NULL) {
			particles[i]->drawParticle();
		}
	}
	for (int i=0; i<PDUST_NUM; i++)
	{
		if (pdusts[i] != NULL) {
			pdusts[i]->drawParticle();
		}
	}

	//now need some picking
	startPicking();

	// :: - draw blocks
	for (int i=0; i<BLOCK_NUM; i++) {
		blocks[i]->drawBoundingBox();
	}
	for (int i=0; i<ENEMY_NUM; i++) {
		if (tanks[i] != NULL)
			tanks[i]->drawBoundingBox();
	}
	stopPicking();
	
	// draw screen HUD
	OrthoMode();
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	glEnable(GL_BLEND);										

	T_Gan.SetActive();
	drawTexturedQuad(n_ScreenX/2-15,n_ScreenY/2,n_ScreenX/2+15,n_ScreenY/2+30);
	glBlendFunc(GL_ONE,GL_ONE);
	
	// W check
	//if (missile_target.y >= 0) glColor3f(1,0,0);
	//else if (missile_target.y < 0) glColor3f(1,1,1);
	// Bind the scope texture to this next 2D quad
	T_GanR.SetActive();

	// Display a 2D quad with our scope texture
	drawTexturedQuad(n_ScreenX/2-15,n_ScreenY/2,n_ScreenX/2+15,n_ScreenY/2+30);

	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	/// mask of number
	switch(n_BF%10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE,n_ScreenX,n_ScreenY);

	switch((n_BF%100)/10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE,n_ScreenX-CHARSIZE,n_ScreenY);
	
	switch((n_BF%1000)/100)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE,n_ScreenX-CHARSIZE*2,n_ScreenY);

	switch((n_BF%10000)/1000)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE,n_ScreenX-CHARSIZE*3,n_ScreenY);
////////////////////////////////////////////////////////
		switch(n_BH%10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE*2,n_ScreenX,n_ScreenY-CHARSIZE);

	switch((n_BH%100)/10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE*2,n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE);
	
	switch((n_BH%1000)/100)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE*2,n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE);

	switch((n_BH%10000)/1000)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE*2,n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE);

////////////////////////////////////////////////////////
			switch(n_DeathCNT%10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE*3,n_ScreenX,n_ScreenY-CHARSIZE*2);

	switch((n_DeathCNT%100)/10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE*3,n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE*2);
	
	switch((n_DeathCNT%1000)/100)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE*3,n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE*2);

	switch((n_DeathCNT%10000)/1000)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE*3,n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE*2);


////////////////////////////////////////////////////////
				switch(n_Hurt%10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE*4,n_ScreenX,n_ScreenY-CHARSIZE*3);

	switch((n_Hurt%100)/10)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE*4,n_ScreenX-CHARSIZE,n_ScreenY-CHARSIZE*3);
	
	switch((n_Hurt%1000)/100)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE*4,n_ScreenX-CHARSIZE*2,n_ScreenY-CHARSIZE*3);

	switch((n_Hurt%10000)/1000)
	{
	case 0:
		T0.SetActive();
		break;
	case 1:
		T1.SetActive();
		break;
	case 2:
		T2.SetActive();
		break;
	case 3:
		T3.SetActive();
		break;
	case 4:
		T4.SetActive();
		break;
	case 5:
		T5.SetActive();
		break;
	case 6:
		T6.SetActive();
		break;
	case 7:
		T7.SetActive();
		break;
	case 8:
		T8.SetActive();
		break;
	case 9:
		T9.SetActive();
		break;
	}
	drawTexturedQuad(n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE*4,n_ScreenX-CHARSIZE*3,n_ScreenY-CHARSIZE*3);

	TH_D.SetActive();
	drawTexturedQuad(n_ScreenX-CHARSIZE*8,n_ScreenY-CHARSIZE*4,n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE*3);

	TH_K.SetActive();
	drawTexturedQuad(n_ScreenX-CHARSIZE*8,n_ScreenY-CHARSIZE*3,n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE*2);

	TH_BH.SetActive();
	drawTexturedQuad(n_ScreenX-CHARSIZE*8,n_ScreenY-CHARSIZE*2,n_ScreenX-CHARSIZE*4,n_ScreenY-CHARSIZE);

	TH_BF.SetActive();
	drawTexturedQuad(n_ScreenX-CHARSIZE*8,n_ScreenY-CHARSIZE,n_ScreenX-CHARSIZE*4,n_ScreenY);

////////////////////////////////////////////////////////


    


    glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	PerspectiveMode();


	if (writeMsg) {
		updateText(); 
		writeText(0,0); }

	glutSwapBuffers();
}

int INTRO_counter = FPS_CAP*1;
void DS_Intro()
{
	glClearColor(0,1,1,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	OrthoMode();
	glEnable(GL_TEXTURE_2D);

   	 T_intro.SetActive(); // apply texture

	drawTexturedQuad(0,0,n_ScreenX, n_ScreenY);

	if (--INTRO_counter < 0) {
		n_GameMode = 1;
		glutPassiveMotionFunc(menuMousePassiveFunc);
		glutMouseFunc(menuMouseFunc);
	}

	PerspectiveMode();

	glutSwapBuffers();
}

void DS_Menu()
{
	glClearColor(0,0.2,0.6,1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	OrthoMode();
	glEnable(GL_BLEND);
	glColor3f(1,1,1);
	T_menu.SetActive();
	drawTexturedQuad(0,0,n_ScreenX, n_ScreenY);

	PerspectiveMode();
	
	glDisable(GL_BLEND);

	glPushMatrix();
	gluLookAt(0,0,220,0,0,0,0,1,0);
	for(int i = 0; i < 80; i ++)
 	{
 		MB_array[i]->MB_Display();
 	}
	glPopMatrix();

	glutSwapBuffers();
}

int gameloaded = 1;
void DS_Loading()
{
	if (gameloaded > 0) gameloaded--;
	else if (gameloaded == 0) { initGame(); gameloaded --; }

	//glClearColor(0,0.2,0.6,1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	OrthoMode();

	T_loading.SetActive();
	glColor3f(1,1,1);
	drawTexturedQuad(0,0,n_ScreenX, n_ScreenY);

	PerspectiveMode();

	glutSwapBuffers();
}
void Display()
{
	switch(n_GameMode)
	{
	case 0:
		DS_Intro();
		break;
	case 1:
		DS_Menu();
		break;
	case 2:
		DS_Loading();
		break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																				idle functions

// :: FPS CONTROL 
float timebase=0;

void idle() 
// idle function, game is processed
{
	glutIdleFunc(NULL);
	glutTimerFunc(1000/45, Awake, NULL);
}

void Awake(int value)
{
	currTime = glutGet(GLUT_ELAPSED_TIME);
	processGame();
	getFPS();
	if(FPS<20)
	{player->b_detail = false;}
	else if(player->b_detail == false)
	{player->b_detail = true;}

	Sync(&timebase);
	glutPostRedisplay();

	glutIdleFunc(idle);
}

int emptyIdle_counter = 120;	// to wait to second for loading :: TODO arsham's bool return
void Idle_Shell()
{

	
	for(int i = 0; i < 80 ; i++)
	{
		// fall no grav
		if(Wait(0.02, MB_array[i]->FALL_counter))
		{
			MB_array[i]->f_Posy -= 10.0*(float)MB_array[i]->f_PosyFall/f_BulletTime;
			if(n_TimeMode == 0 && MB_array[i]->f_A !=1)
			{
				MB_array[i]->f_A += (1-MB_array[i]->f_A)/f_BulletTimeTrance;
				StopWhenClose(&MB_array[i]->f_A, 1);
	
			
			
			
			}
			else if(n_TimeMode == 1 && MB_array[i]->f_A != 0.5)
			{
				MB_array[i]->f_A += (0.5-MB_array[i]->f_A)/f_BulletTimeTrance;
				StopWhenClose(&MB_array[i]->f_A, 0.5);
				//cout << "1";
			
			
			
			
			}
			Syncro(&MB_array[i]->FALL_counter);
		}
		if(Wait(0.02, MB_array[i]->ROTATE_counter))
		{
			MB_array[i]->f_Rx += 10.0* (float)MB_array[i]->f_RxSpeed/f_BulletTime;
			MB_array[i]->f_Ry += 10.0* (float) MB_array[i]->f_RySpeed/f_BulletTime;
			MB_array[i]->f_Rz += 10.0* (float)MB_array[i]->f_RzSpeed/f_BulletTime;
			
			Syncro(&MB_array[i]->ROTATE_counter);	
		}
		
		if(Wait(0.5, MB_array[i]->LIFE_counter) && MB_array[i]->f_Posy < -1000)
		{
		
			MB_array[i]->MB_Init();
			Syncro(&MB_array[i]->LIFE_counter);
		}
		

	}
}



void Idle_BulletTime()
{
	if(Wait(0.02, BT_counter))
	{	
		/// slow
		if(n_TimeMode == 1 && f_BulletTime != 5)
		{
			f_BulletTime += (50.0- f_BulletTime)/f_BulletTimeTrance;
			StopWhenClose(&f_BulletTime, 50.00);
			//cout << f_BulletTime;
		}
		///// normal
		else if(n_TimeMode == 0 && f_BulletTime != 1)
		{
			f_BulletTime += (1.0 - f_BulletTime)/f_BulletTimeTrance;
			StopWhenClose(&f_BulletTime, 1.00);
		}

		Syncro(&BT_counter);
	}
}




void emptyIdle()
{
	currTime = glutGet(GLUT_ELAPSED_TIME);
	if (Wait(1000/FPS_CAP, timebase)) {
		//processGame();
		Idle_Shell();
		Idle_BulletTime();
		getFPS();

		if ( n_GameMode == 2) 
		{
			// ask loading,,,
			if (--emptyIdle_counter < 0) {
				// register game idle | mouse*2 | display
				glutPassiveMotionFunc(MousePassiveFunc);
				glutMouseFunc(MouseFunc);
				glutDisplayFunc(renderScene);
				glutIdleFunc(idle);
				glutSetCursor(GLUT_CURSOR_NONE);
				glutKeyboardFunc(keyboard_control);
				glutKeyboardUpFunc(keyboard_up);

				glDisable(GL_TEXTURE_2D);
			}
		}
		Sync(&timebase);
		glutPostRedisplay();
	}
	// while mouse position is not 
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//																					other functions

void changeSize(int w1, int h1) 
// handle windows size change
{
	if(h1 == 0)	h1 = 1;
	
	n_ScreenX = w1; n_ScreenY = h1;
	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, w1, h1);

	// Set the clipping volume
	gluPerspective(90,1.0f * w1 / h1,0.1,12000);

	// setting the camera now
	glMatrixMode(GL_MODELVIEW);
}

void LIGHT()
{
	float white[4] = {1, 1, 1, 1.0};
	float pos[4] = {-1280, 1000, 1280, 0};

	// Lighting (fixed light)
	glEnable(GL_LIGHTING);
	glLightfv( GL_LIGHT0, GL_POSITION, pos);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT0, GL_SPECULAR, white);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_LIGHT0);
}

int main(int argc, char **argv)
// main function
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH  | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(RES_X, RES_Y);
	glutCreateWindow("MetalSlug Enhancement");

	// register glut functions //////////////////
	//glutMotionFunc(MousePassiveFunc);
	glutReshapeFunc(changeSize);
	glutDisplayFunc(Display);
	glutIdleFunc(emptyIdle);

	// set glut state ///////////////////////////
	glutSetKeyRepeat(GLUT_KEY_REPEAT_OFF);
	glPolygonMode(GL_FRONT, GL_FILL);
	//glPolygonMode(GL_BACK, GL_LINE);
	glEnable( GL_DEPTH_TEST );
    glutFullScreen();

	//LIGHT mmm damn
	LIGHT();

	for(int i = 0; i < 80; i ++)
	{
		MB_array[i] = new MenuBack();
	}

	// :: should have all init here
	loadMenuTextures();
    
	glutMainLoop();

	return 0;
}