
#include "renderfunc.h"

int INTRO_counter = FPS_CAP*1;
//int INTROFADE_counter = 0;
//int WHITEIN_counter = 0;
//int BLACKOUT_counter = 0;
//int LOADING_counter = 0;
float f_Alpha = 1.0f;

COGLTexture T_intro, T_menu, T_loading;

void Load_S_Tex()
{
	T_intro.LoadFromFile("Intro.bmp");
	T_menu.LoadFromFile("Menu.bmp");
	T_loading.LoadFromFile("mask.bmp");
}

// use to and from in pairs
void OrthoMode()
{	
	glDisable(GL_LIGHTING);
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glOrtho( 0, n_ScreenX,n_ScreenY,0, -1, 1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}
void PerspectiveMode()
{
	glEnable(GL_LIGHTING);
	glMatrixMode(GL_PROJECTION);

	glPopMatrix();

	glMatrixMode(GL_MODELVIEW);
}

void drawQuad(int startx, int starty, int endx, int endy)
{
	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	
	glBegin( GL_QUADS );
	glTexCoord2f(0.0f, 1.0f);
	//glColor4f( 0,0,1,f_Alpha); // assign color to vertex
	glVertex2f(startx,starty);

	glTexCoord2f(0.0f, 0.0f);
	//glColor3ub( 0,0,0);
	glVertex2f( startx,endy);

	glTexCoord2f(1.0f, 0.0f);
	glVertex2f( endx, endy);

	glTexCoord2f(1.0f, 1.0f);
	//glColor3ub( 255,0,0);
	glVertex2f( endx, starty );

	glEnd();
	//glDisable(GL_BLEND);
}

void Display()
{
	switch(n_GameMode)
	{
	case 0:
		DS_Intro();
		break;
	case 1:
		DS_Menu();
		break;
	case 2:
		DS_Loading();
		break;
	}
}

void DS_Intro()
{
	glClearColor(0,1,1,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	OrthoMode();
	glEnable(GL_TEXTURE_2D);

   	 T_intro.SetActive(); // apply texture

	drawQuad(0,0,n_ScreenX, n_ScreenY);

	if (--INTRO_counter < 0) {
		n_GameMode = 1;
		glutPassiveMotionFunc(menuMousePassiveFunc);
		glutMouseFunc(menuMouseFunc);
	}

	PerspectiveMode();

	glutSwapBuffers();
}

void DS_Menu()
{
	glClearColor(0,0.2,0.6,1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	OrthoMode();

	T_menu.SetActive();
	drawQuad(0,0,n_ScreenX, n_ScreenY);

	PerspectiveMode();
	
	glutSwapBuffers();
}

void DS_Loading()
{
	glClearColor(0,0.2,0.6,1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	OrthoMode();

	T_loading.SetActive();

	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 1.0f);
	glColor3ub( 0,0,255); // assign color to vertex
	glVertex3f( -n_ScreenX/2, n_ScreenY/2, 0.0 );

	glTexCoord2f(0.0f, 0.0f);
	glColor3ub( 0,0,0);
	glVertex3f( -n_ScreenX/2, -n_ScreenY/2, 0.0 );

	glTexCoord2f(1.0f, 0.0f);
	glColor3ub( 100,255,80);
	glVertex3f( n_ScreenX/2, -n_ScreenY/2,0.0);

	glTexCoord2f(1.0f, 1.0f);
	glColor3ub( 255,0,0);
	glVertex3f( n_ScreenX/2, n_ScreenY/2,0.0 );
	glEnd();

	PerspectiveMode();

	glutSwapBuffers();
}

